
// NCPaintTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "NCPaintTest.h"
#include "NCPaintTestDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CNCPaintTestDlg dialog



CNCPaintTestDlg::CNCPaintTestDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CNCPaintTestDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CNCPaintTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CNCPaintTestDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
    ON_WM_NCACTIVATE()
    ON_WM_NCPAINT()
END_MESSAGE_MAP()


// CNCPaintTestDlg message handlers

BOOL CNCPaintTestDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
    
    m_TitleBmp.LoadBitmapA(IDB_TITLE_BITMAP);
    BITMAP tmpBM = {0};
    GetObject(m_TitleBmp.GetSafeHandle(), sizeof(BITMAP), &tmpBM);
    m_TitleRect.left = 0;
    m_TitleRect.top = 0;
    m_TitleRect.right = m_TitleRect.left + tmpBM.bmWidth;
    m_TitleRect.bottom = m_TitleRect.top + tmpBM.bmHeight;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNCPaintTestDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CNCPaintTestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



BOOL CNCPaintTestDlg::OnNcActivate(BOOL bActive)
{
    // TODO: Add your message handler code here and/or call default

   DrawTitle();
   //Default();
   return TRUE;
}


void CNCPaintTestDlg::OnNcPaint()
{
    // TODO: Add your message handler code here
    // Do not call CDialogEx::OnNcPaint() for painting messages
    DrawTitle();
   //Default();
}

void CNCPaintTestDlg::DrawTitle()
{
    CDC *pDC = GetWindowDC();

    
    CRect windowRect;
    GetWindowRect(windowRect);
    ScreenToClient(windowRect);
    TRACE("Window rect is:  %d, %d, %d, %d\n", windowRect.left, windowRect.top, windowRect.right, windowRect.bottom);
    CRect clipRect;
    pDC->GetClipBox(&clipRect);
    TRACE("Clip region is:  %d, %d, %d, %d\n", clipRect.left, clipRect.top, clipRect.right, clipRect.bottom);
    //clipRect = windowRect;
    //clipRect.bottom += abs(clipRect.top);
    //clipRect.right += abs(clipRect.left);
    //clipRect.left = clipRect.top = 0;
    //CRgn clipRgn;
    //clipRgn.CreateRectRgn(clipRect.left, clipRect.top, clipRect.right, clipRect.bottom);
    //int nRes = pDC->SelectClipRgn(&clipRgn);
    //pDC->GetClipBox(&clipRect);
    //TRACE("Clip region after set is:  %d, %d, %d, %d\n", clipRect.left, clipRect.top, clipRect.right, clipRect.bottom);

    CRect rectClient = windowRect;
    GetClientRect(&rectClient);
    if (windowRect.top < 0)
    {
        rectClient.OffsetRect(-windowRect.left, -windowRect.top);
        rectClient.top -= GetSystemMetrics(SM_CYMENU);
    }
    else
        rectClient.top += GetSystemMetrics(SM_CYMENU);
    TRACE("Exclude clip region is:  %d, %d, %d, %d\n", rectClient.left, rectClient.top, rectClient.right, rectClient.bottom);
    pDC->ExcludeClipRect(&rectClient);
    pDC->GetClipBox(&clipRect);
    TRACE("Clip region after exclude is:  %d, %d, %d, %d\n", clipRect.left, clipRect.top, clipRect.right, clipRect.bottom);

    ::GetUpdateRect(GetSafeHwnd(), &clipRect, FALSE);
    TRACE("Update rect after exclude is:  %d, %d, %d, %d\n", clipRect.left, clipRect.top, clipRect.right, clipRect.bottom);

    CRect tmpRect = windowRect;
    tmpRect.bottom += 70; //GetSystemMetrics(SM_CYDLGFRAME);
    tmpRect.right += 30; //GetSystemMetrics(SM_CXDLGFRAME);
    pDC->FillSolidRect(&tmpRect, RGB(64, 64, 64));

    CDC titleBMDC;
    titleBMDC.CreateCompatibleDC(pDC);
    CBitmap *pOldBitmap = titleBMDC.SelectObject(&m_TitleBmp);
    pDC->BitBlt(2, 2, m_TitleRect.Width(), m_TitleRect.Height(), &titleBMDC, 0, 0, SRCCOPY);

    titleBMDC.SelectObject(pOldBitmap);

    ReleaseDC(pDC);
}
